<?php
/**
 * @category   Bluethink
 * @package    Bluethink_CustomCatalog
 * @author     santosh.bluethink@gmail.com
 * @copyright  This file was generated by using Module Creator(http://code.vky.co.in/magento-2-module-creator/) provided by VKY <viky.031290@gmail.com>
 * @license    http://opensource.org/licenses/osl-3.0.php  Open Software License (OSL 3.0)
 */

namespace Bluethink\CustomCatalog\Block;

use Magento\Framework\View\Element\Template\Context;
use Bluethink\CustomCatalog\Model\CustomCatalogFactory;
/**
 * CustomCatalog List block
 */
class CustomCatalogListData extends \Magento\Framework\View\Element\Template
{
    /**
     * @var CustomCatalog
     */
    protected $_customcatalog;
    public function __construct(
        Context $context,
        CustomCatalogFactory $customcatalog
    ) {
        $this->_customcatalog = $customcatalog;
        parent::__construct($context);
    }

    public function _prepareLayout()
    {
        $this->pageConfig->getTitle()->set(__('Bluethink CustomCatalog Module List Page'));
        
        if ($this->getCustomCatalogCollection()) {
            $pager = $this->getLayout()->createBlock(
                'Magento\Theme\Block\Html\Pager',
                'bluethink.customcatalog.pager'
            )->setAvailableLimit(array(5=>5,10=>10,15=>15))->setShowPerPage(true)->setCollection(
                $this->getCustomCatalogCollection()
            );
            $this->setChild('pager', $pager);
            $this->getCustomCatalogCollection()->load();
        }
        return parent::_prepareLayout();
    }

    public function getCustomCatalogCollection()
    {
        $page = ($this->getRequest()->getParam('p'))? $this->getRequest()->getParam('p') : 1;
        $pageSize = ($this->getRequest()->getParam('limit'))? $this->getRequest()->getParam('limit') : 5;

        $customcatalog = $this->_customcatalog->create();
        $collection = $customcatalog->getCollection();
        $collection->addFieldToFilter('status','1');
        //$customcatalog->setOrder('customcatalog_id','ASC');
        $collection->setPageSize($pageSize);
        $collection->setCurPage($page);

        return $collection;
    }

    public function getPagerHtml()
    {
        return $this->getChildHtml('pager');
    }
}